//+------------------------------------------------------------------+
//|                                              MathSample_test.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property script_show_inputs

//#include <Math\Stat\Math.mqh>
#include "Math_fix.mqh"

input int  population=9;
input int  samplesize=4;     // sample size
input bool replacement=true; // replacement (repetition is allowed)
input int  num_draws=10;     // number of draws
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {
   PrintFormat("MathSample(population=%i,samplesize=%i,replacement=%s)",population,samplesize,replacement?"true":"false");

//--- prepare the population array
   int array[];
   MathSequenceByCount(1,population,population,array);

//--- initialize the generator of random numbers
   MathSrand(GetTickCount()^(uint)ChartID());

//--- draw 10 simple random samples
   int result[];
   for(int i=0; i<num_draws; i++)
      if(MathSample(array,samplesize,replacement,result))
         ArrayPrint(result);
  }
//+------------------------------------------------------------------+

//sample output using the original header <Math\Stat\Math.mqh>
/*
MathSample_demo (CHFJPY,M1)   MathSample(population=9,samplesize=4,replacement=true)
MathSample_demo (CHFJPY,M1)   3 2 1 4
MathSample_demo (CHFJPY,M1)   3 2 1 4
MathSample_demo (CHFJPY,M1)   1 2 3 4
MathSample_demo (CHFJPY,M1)   2 3 1 4
MathSample_demo (CHFJPY,M1)   3 1 2 4
MathSample_demo (CHFJPY,M1)   2 1 3 4
MathSample_demo (CHFJPY,M1)   1 3 2 4
MathSample_demo (CHFJPY,M1)   3 2 1 4
MathSample_demo (CHFJPY,M1)   1 2 3 4
MathSample_demo (CHFJPY,M1)   3 2 1 4
MathSample_demo (CHFJPY,M1)   MathSample(population=9,samplesize=4,replacement=false)
MathSample_demo (CHFJPY,M1)   2 3 1 2
MathSample_demo (CHFJPY,M1)   1 2 3 2
MathSample_demo (CHFJPY,M1)   1 2 3 3
MathSample_demo (CHFJPY,M1)   3 2 1 3
MathSample_demo (CHFJPY,M1)   1 3 1 1
MathSample_demo (CHFJPY,M1)   2 3 1 1
MathSample_demo (CHFJPY,M1)   2 3 3 3
MathSample_demo (CHFJPY,M1)   2 3 1 3
MathSample_demo (CHFJPY,M1)   3 3 1 1
MathSample_demo (CHFJPY,M1)   3 2 1 3
*/

//sample output using the fixed header "Math_fix.mqh""
/*
MathSample_demo (CHFJPY,M1)   MathSample(population=9,samplesize=4,replacement=true)
MathSample_demo (CHFJPY,M1)   6 5 1 7
MathSample_demo (CHFJPY,M1)   4 2 1 6
MathSample_demo (CHFJPY,M1)   3 3 7 1
MathSample_demo (CHFJPY,M1)   9 5 4 2
MathSample_demo (CHFJPY,M1)   2 7 3 5
MathSample_demo (CHFJPY,M1)   5 3 5 4
MathSample_demo (CHFJPY,M1)   3 7 3 8
MathSample_demo (CHFJPY,M1)   9 9 4 9
MathSample_demo (CHFJPY,M1)   7 1 2 5
MathSample_demo (CHFJPY,M1)   5 7 6 5
MathSample_demo (CHFJPY,M1)   MathSample(population=9,samplesize=4,replacement=false)
MathSample_demo (CHFJPY,M1)   6 4 8 1
MathSample_demo (CHFJPY,M1)   5 1 6 9
MathSample_demo (CHFJPY,M1)   4 9 2 6
MathSample_demo (CHFJPY,M1)   1 8 4 6
MathSample_demo (CHFJPY,M1)   4 8 9 7
MathSample_demo (CHFJPY,M1)   3 8 4 7
MathSample_demo (CHFJPY,M1)   2 3 4 7
MathSample_demo (CHFJPY,M1)   1 7 3 4
MathSample_demo (CHFJPY,M1)   9 4 7 8
MathSample_demo (CHFJPY,M1)   1 9 2 5
*/
